import IMP
import IMP.core

class AssemblyRestraints:
    def __init__(self, assemb):
	self.assemb = assemb
        self.known_rsrs = ['exclvol', 'y2h', 'array', 'crystal', 'xlink', 
	                   'ms_ms', 'subcomplex', 'interprot_chain',
			   'co-purification', 'pulldown', 'em',
			   'rigid_bodies', 'max_diameter', 'in_vitro_binding'] # known restraint types
        # pointers for restraints
        self.restraint_sets = {}
        for rs_type_name in self.known_rsrs:
	    self.ini_restraint(rs_type_name)

    def __del__(self):
        for rs_name in self.known_rsrs:
	    self.restraint_sets[rs_name].clear_restraints()
	    self.restraint_sets[rs_name].__del__()
	    print "deleting Restraint Sets"


    def ini_restraint(self, rs_type_name):
        try:
            self.restraint_sets[rs_type_name] = IMP.core.RestraintSet(rs_type_name)
        except KeyError:
            print "restraint name "+rs_type_name +" not known"
        self.assemb.add_restraint(self.restraint_sets[rs_type_name])

class assembly(IMP.Model):
    def __init__(self):
        IMP.Model.__init__(self)
        IMP.set_log_level(IMP.SILENT)
	self.restraints = AssemblyRestraints(self)

    def __del__(self):
	self.clear_restraints()
        for b in self.__class__.__bases__:
	    print "deleting assembly"
            b.__del__(self)
	self.restraints.__del__()


for ii in range(0,50000):
    xxx = assembly()
    xxx.__del__()

